# vim: set ft=spec: -*- rpm-spec -*-
# $Id: i386-mingw32msvc-gcc,v 1.20 2005/05/24 09:03:38 raorn Exp $

%mingw_tool

%define pkgname gcc

Name: %cross_arch-%pkgname
Version: 3.4.3
Release: alt3

Summary: GNU Compiler Collection
License: GPL
Group: Development/Other
URL: http://gcc.gnu.org/

%define gcc_branch 3.4
%define snapshot 20050222
%define srcver %version-%snapshot
%define srcfilename gcc-%srcver
%define srcdirname gcc-%srcver
%define os_release %distribution, build %version-%release
%define _libexecdir /usr/libexec
%define _archlibexecdir %_prefix/%cross_arch/libexec

%define gcc_target_libdir %_libdir/gcc/%cross_arch/%version
%define gcc_target_libexecdir %_libexecdir/gcc/%cross_arch/%version

# Build parameters.
%def_disable debug
%def_with fortran
%def_with objc
%def_without treelang
%def_without java
%def_with ada
%def_without pdf
%def_without bootstrap

#if_with bootstrap
%define runver	3.2
%define	runsrc	mingw-runtime-%runver
%define	apiver	2.5
%define	apisrc	w32api-%apiver
#endif 

Source: %srcfilename.tar.bz2
#if_with bootstrap
Source1: %runsrc.tar.gz
Source2: %apisrc.tar.gz
#endif

Patch1: gcc-3.4.3-20050228.patch
Patch2: gcc-3.4.3-20050314.patch

# MinGW patches.
Patch010: gcc342-mingw-alt-fixes.patch

# RH patches.
#Patch101: gcc34-rh-multi32-hack.patch
Patch102: gcc34-rh-ice-hack.patch
#Patch103: gcc34-rh-ppc64-m32-m64-multilib-only.patch
#Patch104: gcc34-rh-ia64-lib64.patch
#Patch105: gcc34-rh-java-nomulti.patch
#Patch106: gcc34-rh-gnuc-rh-release.patch
Patch107: gcc34-rh-pr16104.patch
Patch108: gcc-rh-pr17406.patch

# Debian patches.
Patch201: gcc34-deb-gcc-textdomain.patch
#Patch202: gcc34-deb-libstdc++-doclink.patch
Patch203: gcc34-deb-protoize.patch
#Patch204: gcc34-deb-amd64-specs.patch
#Patch205: gcc34-deb-fastjar-update.patch
#Patch206: gcc34-deb-gcj-without-rpath.patch
#Patch207: gcc34-deb-libffi-soversion.patch
#Patch208: gcc34-deb-libobjc.patch
#Patch209: gcc34-deb-ada-gcc-name.patch
Patch210: gcc34-deb-cpu-default-i586.patch
Patch211: gcc34-deb-link-libs.patch

# SuSE patches.
#Patch501:

# MDK patches.
Patch601: gcc32-mdk-mklibgcc-serialize-crtfiles.patch
Patch602: gcc32-mdk-multi-do-libdir.patch

# ALT patches.
Patch701: gcc32-alt-libobjc_makefile.patch
Patch702: gcc34-alt-install.patch
Patch703: gcc34-alt-nowrap.patch
Patch704: gcc34-alt-gnatdll.patch

# PLD patches.
Patch801: gcc33-pld-noioctl.patch

# GNU patches.
Patch901: gcc34-gnu-gthr-win32-fixes.patch

PreReq: i386-mingw32msvc-binutils

Obsoletes: mingw32-gcc
Provides: mingw32-gcc = %version-%release

BuildPreReq: i386-mingw32msvc-devel >= 0.0.2
BuildPreReq: flex i386-mingw32msvc-binutils zlib-devel
BuildPreReq: gcc%gcc_branch
%if_with ada
BuildPreReq: gcc%gcc_branch-gnat
%endif
%if_without bootstrap
BuildPreReq: i386-mingw32msvc-runtime
%endif

BuildPreReq: rpm-build >= 4.0.4-alt10, autoconf_2.5, automake_1.7
%set_autoconf_version 2.5
%set_automake_version 1.7
%set_gcc_version %gcc_branch

%description
This package contains the GNU Compiler Collection version %version.
You'll need this package in order to crosscompile C code.
It is also required for all other GCC crosscompilers, namely C++,
Fortran 77, Objective C, Java and Ada.

This package contains crosscompilation tools for %cross_arch
target.

%package c++
Summary: C++ support for %name
Group: Development/Other
Requires: %name = %version-%release
Obsoletes: mingw32-gcc-c++
Provides: mingw32-gcc-c++ = %version-%release

%description c++
This package provides support for crosscompiling C++ programs
with the GNU Compiler Collection.
It includes support for most of the current C++ specification,
including templates and exception handling.

This package contains crosscompilation tools for %cross_arch
target.

%if_with fortran
%package g77
Summary: Fortran 77 support for %name
Group: Development/Other
Requires: %name = %version-%release
Obsoletes: mingw32-gcc-g77
Provides: mingw32-gcc-g77 = %version-%release

%description g77
This package provides support for crosscompiling Fortran 77
programs with the GNU Compiler Collection.

This package contains crosscompilation tools for %cross_arch
target.
%endif

%if_with objc
%package objc
Summary: Objective-C support for %name
Group: Development/Objective-C
Requires: %name = %version-%release
Obsoletes: mingw32-gcc-objc
Provides: mingw32-gcc-objc = %version-%release

%description objc
This package provides support for crosscompiling Objective-C
programs with the GNU Compiler Collection.
Mainly used on systems running NeXTSTEP(tm), Objective-C is
an object-oriented derivative of the C language.

This package contains crosscompilation tools for %cross_arch
target.
%endif

%if_with ada
%package gnat
Summary: Ada support for %name
Group: Development/Other
Requires: %name = %version-%release
Obsoletes: mingw32-gcc-gnat
Provides: mingw32-gcc-gnat = %version-%release

%description gnat
This package provides support for crosscompiling Ada programs
with the GNU Compiler Collection.

This package contains crosscompilation tools for %cross_arch
target.
%endif

%if_with java
%package java
Summary: Java support for %name
Group: Development/Java
Requires: %name = %version-%release

%description java
This package adds support for crosscompiling Java(tm) programs
and bytecode into native code.

This package contains crosscompilation tools for %cross_arch
target.
%endif

%prep
%setup -q -n %srcdirname
%if_with bootstrap
%__mkdir_p winsup
%__tar xzf %SOURCE1 -C winsup
%__tar xzf %SOURCE2 -C winsup
%endif
find -type d -name CVS -print0 |
	xargs -r0 rm -rf --

%patch1 -p1
%patch2 -p0

# MinGW patches.
%patch010 -p1

# RH patches.
#patch101 -p0
%patch102 -p0
#patch103 -p0
#patch104 -p0
#patch105 -p0
#patch106 -p0
%patch107 -p0
%patch108 -p1


# Debian patches.
%patch201 -p0
#patch202 -p0
%patch203 -p0
#patch204 -p1
#patch205 -p0
#patch206 -p1
#patch207 -p0
#patch208 -p0
#patch209 -p0
%patch210 -p0
%patch211 -p0

# SuSE patches.
#patch501 -p0

# MDK patches.
%patch601 -p1
%patch602 -p1

# ALT patches.
%patch701 -p0
%patch702 -p1
%patch703 -p1
%patch704 -p1

# PLD patches.
%patch801 -p1

# GNU patches.
%patch901 -p1

# Set proper version & contact info.
%__cp -p gcc/version.c gcc/version.c.orig
%__subst 's/3\.4\.4/%version/g' gcc/version.c
%__subst 's/\(%gcc_branch\(\.[0-9]\+\)*\)\( [0-9]\+[a-z]*\)\?.*"/\1\3 (%os_release)"/' gcc/version.c
%__subst 's,<URL:[^>]*>,<URL:http://bugzilla.altlinux.ru/>,' gcc/version.c

%build
%if_with bootstrap
for f in %_archbindir/*; do
	%__ln_s "$f" "winsup/bin/${f##*/}"
done
%endif
for f in */Makefile.am; do
	(cd "${f%/*}" && [ Makefile.am -nt Makefile.in ] && %__aclocal && %__automake)
done
for f in */configure.ac; do
	(cd "${f%/*}" && [ configure.ac -nt configure ] && %__autoconf)
done
for f in */configure.in; do
	(cd "${f%/*}" && [ configure.in -nt configure ] && %__autoconf)
done

%define buildtarget build-%cross_arch
%__rm -rf %buildtarget
%__mkdir_p %buildtarget
pushd %buildtarget

CC=gcc
%remove_optflags %optflags_nocpp %optflags_notraceback

CC="$CC" \
CFLAGS="$RPM_OPT_FLAGS" \
CXXFLAGS="$RPM_OPT_FLAGS" \
GCJFLAGS="$RPM_OPT_FLAGS" \
XCFLAGS="$RPM_OPT_FLAGS" \
TCFLAGS="$RPM_OPT_FLAGS" \
	../configure --prefix=%_prefix \
	--includedir=%_archincludedir \
	--libdir=%_libdir \
	--mandir=%_mandir \
	--infodir=%_infodir \
	--disable-checking \
	--enable-long-long \
	--disable-__cxa_atexit \
	--enable-languages="c,c++%{?_with_fortran:,f77}%{?_with_objc:,objc}%{?_with_treelang:,treelang}%{?_with_java:,java}%{?_with_ada:,ada}" \
	--enable-objc-gc \
	--enable-libgcj \
	--with-gnu-as \
	--with-gnu-ld \
	--enable-threads=win32 \
	--with-gxx-include-dir=%_archincludedir/c++/%version \
	--with-system-zlib \
	--without-included-gettext \
	--disable-nls \
	--without-newlib \
	--disable-multilib \
	--program-prefix=%cross_arch- \
	%_configure_target

%make_build \
	%{?_with_bootstrap:build_tooldir="$(pwd)/../winsup"}

%if_with ada
# SMP-incompatible build.
%make -C gcc gnatlib \
	%{?_with_bootstrap:GNATLIBCFLAGS="-g -O2 -I$(pwd)/../winsup/include"}
%make -C gcc cross-gnattools
# Hack for gnat tools' names
%make -C gcc all \
	%{?_with_bootstrap:build_tooldir="$(pwd)/../winsup"}
%endif #with_ada

popd #%buildtarget

%install
%__mkdir_p %buildroot%_archlibdir
pushd %buildtarget
%make_install \
	DESTDIR=%buildroot \
	install
popd #%buildtarget

# Collect some garbage.
pushd %buildroot%_bindir
	%__rm -f %cross_arch-addr2name.awk*
	%__rm -f %cross_arch-*.exe
	%__rm -f %cross_arch-gcc-%version
	%__rm -f %cross_arch-gccbug
	%__rm -f %cross_arch-%cross_arch-*
	%{?_with_ada:%__ln_s %cross_arch-gcc %cross_arch-gnatgcc}
	%{?_with_ada:%__rm -f vxaddr2line}
popd

pushd %buildroot%_archlibdir
	%__rm -f libiberty.a
	%__mv *.*a %buildroot%gcc_target_libdir/
popd

%if_with ada
# Dispatch Ada 95 libraries.
pushd %buildroot%gcc_target_libdir
	for n in gnat gnarl; do
		%__rm -f adalib/lib$n.so.*
	done
	%__mv adalib/*.*a .
popd
%endif #with_ada

%if_with java
# Relocate Java headers to version-specific compiler directory.
%__mv %buildroot%_archincludedir/{ffi,j}*.h %buildroot%gcc_target_libdir/include/
%__mv %buildroot%_archincludedir/{java,javax,gnu} %buildroot%gcc_target_libdir/include/
%__mv %buildroot%_archincludedir/gcj/* %buildroot%gcc_target_libdir/include/gcj/
rmdir %buildroot%_archincludedir/gcj

# Fix libgcj.spec and move it to compiler-specific directory.
%__subst -p 's/-lgcjgc//g;s/-lzgcj//g;s/-lpthread//g' %buildroot%_archlibdir/libgcj.spec
%__mv %buildroot%_archlibdir/libgcj.spec %buildroot%gcc_target_libdir/
%endif #with_java

%__rm -rf %buildroot%_datadir
%__rm -rf %buildroot%_libdir/libiberty.*a
%__rm -rf %buildroot%gcc_target_libdir/install-tools

%files
%_bindir/%cross_arch-cpp
%_bindir/%cross_arch-gcc
%_bindir/%cross_arch-gcov
%_bindir/%cross_arch-protoize
%_bindir/%cross_arch-unprotoize
%dir %gcc_target_libdir
%gcc_target_libdir/SYSCALLS.c.X
%gcc_target_libdir/libgcc*.a
%gcc_target_libdir/libgcov*.a
%gcc_target_libdir/*.o
%gcc_target_libdir/specs
%dir %gcc_target_libdir/include
%gcc_target_libdir/include/README
%gcc_target_libdir/include/float.h
%gcc_target_libdir/include/*mmintrin.h
%gcc_target_libdir/include/iso646.h
%gcc_target_libdir/include/limits.h
%gcc_target_libdir/include/stdarg.h
%gcc_target_libdir/include/stdbool.h
%gcc_target_libdir/include/stddef.h
%gcc_target_libdir/include/syslimits.h
%gcc_target_libdir/include/unwind.h
%gcc_target_libdir/include/varargs.h
%dir %gcc_target_libexecdir
%gcc_target_libexecdir/cc1
%gcc_target_libexecdir/collect2

%files c++
%_bindir/%cross_arch-c++
%_bindir/%cross_arch-g++
%dir %_archincludedir/c++
%_archincludedir/c++/*
%dir %gcc_target_libdir
%gcc_target_libdir/libstdc++.*a
%gcc_target_libdir/libsupc++.*a
%dir %gcc_target_libexecdir
%gcc_target_libexecdir/cc1plus

%if_with fortran
%files g77
%_bindir/%cross_arch-g77
%dir %gcc_target_libdir
%gcc_target_libdir/libfrtbegin.*a
%gcc_target_libdir/libg2c.*a
%dir %gcc_target_libdir/include
%gcc_target_libdir/include/g2c.h
%dir %gcc_target_libexecdir
%gcc_target_libexecdir/f771
%endif

%if_with objc
%files objc
%gcc_target_libdir/libobjc*.*a
%dir %gcc_target_libdir/include
%gcc_target_libdir/include/objc
%gcc_target_libexecdir/cc1obj
%endif

%if_with java
%files java
%_bindir/%cross_arch-gcj*
%_bindir/%cross_arch-*jar
%_bindir/%cross_arch-jcf-dump
%_bindir/%cross_arch-jv-scan
%dir %gcc_target_libdir
%gcc_target_libdir/lib-org-*.*a
%gcc_target_libdir/libffi.*a
%gcc_target_libdir/libgcj.*a
%gcc_target_libdir/libgcj.spec
%dir %gcc_target_libdir/include
%gcc_target_libdir/include/java
%gcc_target_libdir/include/javax
%gcc_target_libdir/include/gnu
%gcc_target_libdir/include/gcj
%gcc_target_libdir/include/ffi*.h
%gcc_target_libdir/include/j*.h
%gcc_target_libdir/include/libffi
%dir %gcc_target_libexecdir
%gcc_target_libexecdir/jc1
%gcc_target_libexecdir/jvgenmain
%endif

%if_with ada
%files gnat
%_bindir/%cross_arch-gnat*
%dir %gcc_target_libdir
%gcc_target_libdir/ada*
%gcc_target_libdir/libgna*.*a
%gcc_target_libdir/libgmem.*a
%dir %gcc_target_libexecdir
%gcc_target_libexecdir/gnat1
%endif

%changelog
* Tue May 24 2005 Sir Raorn <raorn@altlinux.ru> 3.4.3-alt3
- Added patch for GCC#17406 (closes: #6259)

* Mon May 23 2005 Sir Raorn <raorn@altlinux.ru> 3.4.3-alt2
- Updated to gcc3.4-3.4.3-alt6
- Disabled java (b0rken make)

* Wed Feb 02 2005 Sir Raorn <raorn@altlinux.ru> 3.4.3-alt1
- [3.4.3] (based on gcc3.4-3.4.3-alt2 by ldv)
- BuildRequre gcc from the same branch

* Sun Oct 03 2004 Sir Raorn <raorn@altlinux.ru> 3.3.3-alt4
- Some hackarounds, versioned builddeps

* Mon Sep 20 2004 Sir Raorn <raorn@altlinux.ru> 3.3.3-alt3.1
- Oops! Somehow -alt2.2 changes were lost...

* Mon Sep 20 2004 Sir Raorn <raorn@altlinux.ru> 3.3.3-alt3
- Rebuilt with i386-mingw32msvc-devel

* Thu May 13 2004 Sir Raorn <raorn@altlinux.ru> 3.3.3-alt2.2
- Partialy applied "official" MinGW patch (closes #4110)
- Added missing crtbegin.o/crtend.o to filelist

* Fri Apr 09 2004 Sir Raorn <raorn@altlinux.ru> 3.3.3-alt2.1
- Disabled __cxa_atexit (Closes: #3938)

* Tue Apr 06 2004 Sir Raorn <raorn@altlinux.ru> 3.3.3-alt2
- Renamed to %cross_arch-gcc
- Synced with gcc3.3-3.3.3-alt2
- Added Ada and Java backends

* Fri Jun 27 2003 Sir Raorn <raorn@altlinux.ru> 3.3-alt1
- [3.3]

* Sun May 11 2003 Sir Raorn <raorn@altlinux.ru> 3.2.3-alt7
- Subst gcc_tooldir... Hope this will be enough...

* Sun May 11 2003 Sir Raorn <raorn@altlinux.ru> 3.2.3-alt6
- Argh! tooldir_base_prefix was too deep...

* Sun May 11 2003 Sir Raorn <raorn@altlinux.ru> 3.2.3-alt5
- Hardcode tooldir_base_prefix

* Sun May 11 2003 Sir Raorn <raorn@altlinux.ru> 3.2.3-alt4
- Reconfigure with different layout...

* Sun May 11 2003 Sir Raorn <raorn@altlinux.ru> 3.2.3-alt3
- Fix as and ld names

* Sun May 11 2003 Sir Raorn <raorn@altlinux.ru> 3.2.3-alt2
- Fix requires

* Sat May 10 2003 Sir Raorn <raorn@altlinux.ru> 3.2.3-alt1
- Built for Sisyphus
 (Based on avr-* packages by week, crossutils-mingw32 by vsl and gcc by ldv)





